HDU 1224 Free DIY Tour(DP)

Problem Description

Weiwei is a software engineer of ShiningSoft. He has just excellently fulfilled a software project with his fellow workers. His boss is so satisfied with their job that he decide to provide them a free tour around the world. It‘s a good chance to relax themselves.
To most of them, it‘s the first time to go abroad so they decide to make a collective tour.

The tour company shows them a new kind of tour circuit - DIY circuit. Each circuit contains some cities which can be selected by tourists themselves. According to the company‘s statistic, each city has its own interesting point. For instance, Paris has its
interesting point of 90, New York has its interesting point of 70, ect. Not any two cities in the world have straight flight so the tour company provide a map to tell its tourists whether they can got a straight flight between any two cities on the map. In
order to fly back, the company has made it impossible to make a circle-flight on the half way, using the cities on the map. That is, they marked each city on the map with one number, a city with higher number has no straight flight to a city with lower number.

Note: Weiwei always starts from Hangzhou(in this problem, we assume Hangzhou is always the first city and also the last city, so we mark Hangzhou both 1 andN+1), and its interesting point is always 0.

Now as the leader of the team, Weiwei wants to make a tour as interesting as possible. If you were Weiwei, how did you DIY it?

Input

The input will contain several cases. The first line is an integer T which suggests the number of cases. Then T cases follows.

Each case will begin with an integer N(2 ≤ N ≤ 100) which is the number of cities on the map.

Then N integers follows, representing the interesting point list of the cities.

And then it is an integer M followed by M pairs of integers [Ai, Bi] (1 ≤ i ≤ M). Each pair of [Ai, Bi] indicates that a straight flight is available from City Ai to City Bi.

Output

For each case, your task is to output the maximal summation of interesting points Weiwei and his fellow workers can get through optimal DIYing and the optimal circuit. The format is as the sample. You may assume that there is only one optimal circuit.

Output a blank line between two cases.

Sample Input

2
3
0 70 90
4
1 2
1 3
2 4
3 4
3
0 90 70
4
1 2
1 3
2 4
3 4

Sample Output

CASE 1#
points : 90
circuit : 1->3->1

CASE 2#
points : 90
circuit : 1->2->1

Author

JGShining(极光炫影)

题意:给旅游景点一个权值,求最大的值。递归输出。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<limits.h>
typedef long long LL;
using namespace std;
int mp[110][110],a[110];
int dp[110],pre[110];
int t,n,m;
void print(int x)
{
    if(x==1)
    {
        printf("1");
        return ;
    }
    print(pre[x]);
    printf("->%d",x);
}
int main()
{
    int cas=0;
    int u,v;
    scanf("%d",&t);
    while(t--)
    {
        if(cas)
            printf("\n");
        cas++;
        scanf("%d",&n);
        memset(mp,0,sizeof(mp));
        memset(dp,0,sizeof(dp));
        memset(pre,0,sizeof(pre));
        for(int i=1;i<=n;i++)
            scanf("%d",&a[i]);
        a[n+1]=0;
        scanf("%d",&m);
        for(int i=1;i<=m;i++)
        {
            scanf("%d%d",&u,&v);
            mp[u][v]=1;
        }
        for(int i=1;i<=n+1;i++)
        {
            for(int j=1;j<=n+1;j++)
            {
                if(mp[j][i])
                {
                    if(dp[i]<dp[j]+a[i])//条件限制
                    {
                      dp[i]=max(dp[i],dp[j]+a[i]);
                      pre[i]=j;//记录前驱
                    }
                }
            }
        }
        printf("CASE %d#\n",cas);
        printf("points : %d\n",dp[n+1]);
        ;printf("circuit : ");
        print(pre[n+1]);
        printf("->1\n");
    }
    return 0;
}

HDU 1224 Free DIY Tour(DP)

时间: 2024-10-18 20:02:15

HDU 1224 Free DIY Tour(DP)的相关文章

hdu 1224 Free DIY Tour(最长路/dp)

http://acm.hdu.edu.cn/showproblem.php?pid=1224 基础的求最长路以及记录路径.感觉dijstra不及spfa好用,wa了两次. #include <stdio.h> #include <algorithm> #include <set> #include <map> #include <vector> #include <math.h> #include <string.h> #

HDU 1224 Free DIY Tour 简单DP

Free DIY Tour Problem Description Weiwei is a software engineer of ShiningSoft. He has just excellently fulfilled a software project with his fellow workers. His boss is so satisfied with their job that he decide to provide them a free tour around th

hdu 1224 Free DIY Tour(最长的公路/dp)

http://acm.hdu.edu.cn/showproblem.php? pid=1224 基础的求最长路以及记录路径. 感觉dijstra不及spfa好用,wa了两次. #include <stdio.h> #include <algorithm> #include <set> #include <map> #include <vector> #include <math.h> #include <string.h>

hdu 1224 Free DIY Tour

这题真是被弄的欲仙欲死啊,开始写的代码死活的a不掉,也不知道哪里错了,先附上,求大牛指点啊..... #include<iostream> #include<algorithm> #include<cstdio> using namespace std; int n,m; int point[100+5]; int re; int ree[105]; int l; struct stu { int a,b; }; stu mapp[100000+5]; void dfs

【HDOJ】1224 Free DIY Tour

DP. 1 #include <cstdio> 2 #include <cstring> 3 #include <cstdlib> 4 #include <algorithm> 5 #include <iostream> 6 using namespace std; 7 8 #define MAXN 105 9 int score[MAXN]; 10 bool map[MAXN][MAXN]; 11 int path[MAXN]; 12 int

HDU 1224 Free DIY Tour--DP--(bug集锦)

题意:有多个城市编号为1到 n分别有不同的评分,现在知道了某些城市之间的直航,找一条从起点出发回到起点.沿途经过的城市总评分最大的路径.要求只能从编号低的             到编号高的,所以起点编号为1和n+1 分析:dp[i]表示从1到i的最优解,dp[i]=max(dp[j]+intr[i]),其中 1<= j< i (这个条件可以保证只从编号低的走到编号高的) 这题一开始思路就是对的,不过不停WA,一路排查了各种bug,其中最重要的两个:1.long long 2.多组case 和

hdu 1224(动态规划 DAG上的最长路)

Free DIY Tour Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 5815    Accepted Submission(s): 1855 Problem Description Weiwei is a software engineer of ShiningSoft. He has just excellently fulfi

hdu 3555 Bomb(数位dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3555 题目大意:就是给你一个数n,判断从0到n有多少个数含有数字49...... 是不是觉得跟hdu2089很相似呀... 思路:跟hdu2089一样的,注意给出的数比较大,所以这儿用__int64  .... code: #include<cstdio> #include<iostream> #include<cstring> #include<algorithm&

HDU 1231 最大连续子序列 DP题解

典型的DP题目,增加一个额外要求,输出子序列的开始和结尾的数值. 增加一个记录方法,nothing special. 记录最终ans的时候,同时记录开始和结尾下标: 更新当前最大值sum的时候,更新开始节点. const int MAX_N = 10001; long long arr[MAX_N]; int N, sta, end; long long getMaxSubs() { long long sum = 0, ans = LLONG_MIN; int ts = 0; for (int